

function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var _this = undefined;
var Formal = function (_a) {
    var initialValues = _a.initialValues, validationSchema = _a.validationSchema, _b = _a.isInitiallyValid, isInitiallyValid = _b === void 0 ? true : _b, children = _a.children, onSubmit = _a.onSubmit;
    var _c = React.useState(initialValues), formData = _c[0], setFormData = _c[1];
    var _d = React.useState(!isInitiallyValid), shouldValidate = _d[0], setShouldValidate = _d[1];
    var _e = React.useState(false), isValid = _e[0], setIsValid = _e[1];
    var _f = React.useState(false), isSubmitting = _f[0], setIsSubmitting = _f[1];
    var _g = React.useState([]), errors = _g[0], setErrors = _g[1];
    var validateForm = React.useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
        var newErrors;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    newErrors = [];
                    validationSchema.forEach(function (item) {
                        if (item.required && formData[item.field] === "") {
                            newErrors.push({
                                field: item.field,
                                message: "This field is required",
                            });
                        }
                    });
                    return [4 /*yield*/, setErrors(newErrors)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [formData]);
    React.useEffect(function () {
        setIsValid(!errors.length ? true : false);
    }, [errors]);
    React.useEffect(function () {
        validateForm();
    }, [formData]);
    React.useEffect(function () {
        if (isSubmitting && isValid) {
            onSubmit({ setIsSubmitting: setIsSubmitting, setErrors: setErrors }, formData);
        }
        else {
            setIsSubmitting(false);
        }
    }, [isSubmitting]);
    var handleFormSubmit = function () {
        setShouldValidate(true);
        setIsSubmitting(true);
    };
    var onChangeValues = function (newValue) {
        setFormData(__assign({}, formData, newValue));
    };
    return (React.createElement("form", { onSubmit: function (event) {
            event.preventDefault();
            handleFormSubmit();
        } }, children({
        values: formData,
        onChangeValues: onChangeValues,
        handleFormSubmit: handleFormSubmit,
        isSubmitting: isSubmitting,
        isValid: !isValid && shouldValidate ? false : true,
        errors: !shouldValidate ? [] : errors,
    })));
};

exports.default = Formal;
//# sourceMappingURL=index.js.map
